// This file is generated by kconfig_compiler from knetwalk.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

class Settings : public KConfigSkeleton
{
  public:

    static Settings *self();
    ~Settings();

    /**
      Set Default user name
    */
    static
    void setUsername( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "username" ) ))
        self()->mUsername = v;
    }

    /**
      Get Default user name
    */
    static
    QString username()
    {
      return self()->mUsername;
    }

    /**
      Set Whether game sounds are played.
    */
    static
    void setPlaySounds( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "PlaySounds" ) ))
        self()->mPlaySounds = v;
    }

    /**
      Get Whether game sounds are played.
    */
    static
    bool playSounds()
    {
      return self()->mPlaySounds;
    }

    /**
      Set The size of the board.
    */
    static
    void setSize( int v )
    {
      if (v < 3)
      {
        kDebug() << "setSize: value " << v << " is less than the minimum value of 3";
        v = 3;
      }

      if (v > 11)
      {
        kDebug() << "setSize: value " << v << " is greater than the maximum value of 11";
        v = 11;
      }

      if (!self()->isImmutable( QString::fromLatin1( "Size" ) ))
        self()->mSize = v;
    }

    /**
      Get The size of the board.
    */
    static
    int size()
    {
      return self()->mSize;
    }

    /**
      Set Whether wrap from left to right and from top to bottom is enabled.
    */
    static
    void setWrapping( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "Wrapping" ) ))
        self()->mWrapping = v;
    }

    /**
      Get Whether wrap from left to right and from top to bottom is enabled.
    */
    static
    bool wrapping()
    {
      return self()->mWrapping;
    }

  protected:
    Settings();
    friend class SettingsHelper;


    // Preferences
    QString mUsername;

    // Sound
    bool mPlaySounds;

    // Custom
    int mSize;
    bool mWrapping;

  private:
};

#endif

